package dcguibuilder;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.io.*;
import Silence.XMLSerializer;

public class DCGUIMain extends JFrame {
  ArrayList widgets = new ArrayList();
  boolean saveAllowed;
  JFileChooser fileDialog = new JFileChooser();
  File fileName;

  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem fileExit = new JMenuItem();
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel GUIEditor = new JPanel();
  JPanel propertyPane = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel guiEditArea = new JPanel();
  JPanel outputPane = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout3 = new BorderLayout();
  JTextArea outputText = new JTextArea();
  Border border1;
  Border border2;

  int bufferX, bufferY;

  JPopupMenu popup = new JPopupMenu();
  JMenuItem menuFLpanel = new JMenuItem();
  BorderLayout borderLayout4 = new BorderLayout();
  JMenuItem fileNew = new JMenuItem();
  JMenuItem fileOpen = new JMenuItem();
  JMenuItem fileSave = new JMenuItem();
  JMenuItem fileSaveAs = new JMenuItem();

  /**Construct the frame*/
  public DCGUIMain() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    saveAllowed = false;
    fileSave.setEnabled(false);
    fileDialog.setAcceptAllFileFilterUsed(true);
    fileDialog.setFileFilter(new DCGUIFilter());

    contentPane = (JPanel) this.getContentPane();
    border1 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(-5,0,-5,-5));
    border2 = BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.cyan,1),BorderFactory.createEmptyBorder(-5,0,-5,-5));
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(800, 600));
    this.setTitle("Direct Csound GUI Builder - build 2 - 2001.5.10 - steven yi");
    statusBar.setText(" ");
    menuFile.setMnemonic('F');
    menuFile.setText("File");
    fileExit.setMnemonic('X');
    fileExit.setText("Exit");
    fileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        programExit();
      }
    });
    GUIEditor.setLayout(borderLayout2);
    propertyPane.setBorder(BorderFactory.createEtchedBorder());
    propertyPane.setMaximumSize(new Dimension(200, 32767));
    propertyPane.setMinimumSize(new Dimension(200, 10));
    propertyPane.setPreferredSize(new Dimension(200, 10));
    propertyPane.setLayout(borderLayout4);
    outputPane.setLayout(borderLayout3);
    outputText.setText("generated text");
    outputText.setToolTipText("");
    guiEditArea.setLayout(null);
    guiEditArea.setBorder(BorderFactory.createEtchedBorder());
    menuFLpanel.setText("add FLpanel");
    menuFLpanel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        addFLPanel();
      }
    });
    outputPane.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(ComponentEvent e) {
        outputPane_componentShown(e);
      }
    });
    fileNew.setMnemonic('N');
    fileNew.setText("New");
    fileNew.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        fileNew();
      }
    });
    fileOpen.setMnemonic('O');
    fileOpen.setText("Open");
    fileOpen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(79, java.awt.event.KeyEvent.CTRL_MASK, false));
    fileOpen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        open();
      }
    });
    fileSave.setMnemonic('S');
    fileSave.setText("Save");
    fileSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(83, java.awt.event.KeyEvent.CTRL_MASK, false));
    fileSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        save();
      }
    });
    fileSaveAs.setMnemonic('V');
    fileSaveAs.setText("Save as...");
    fileSaveAs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveAs();
      }
    });
    menuFile.addSeparator();
    menuFile.add(fileNew);
    menuFile.addSeparator();
    menuFile.add(fileOpen);
    menuFile.addSeparator();
    menuFile.add(fileSave);
    menuFile.add(fileSaveAs);
    menuFile.addSeparator();
    menuFile.add(fileExit);
    jMenuBar1.add(menuFile);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jTabbedPane1, BorderLayout.CENTER);
    jTabbedPane1.add(GUIEditor, "GUIEditor");
    GUIEditor.add(propertyPane, BorderLayout.EAST);
    GUIEditor.add(guiEditArea, BorderLayout.CENTER);
    jTabbedPane1.add(outputPane, "output");
    outputPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(outputText, null);
    popup.add(menuFLpanel);
    guiEditArea.addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        if(SwingUtilities.isRightMouseButton(e)) {
          bufferX = e.getX();
          bufferY = e.getY();
          popup.show(guiEditArea, e.getX(), e.getY());
        }
      }
    });
  }

  public void programExit() {
    System.exit(0);
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      programExit();
    }
  }

  void addFLPanel() {
    WidgetContainer tempWidgetContainer = new FLpanel();
    widgets.add(tempWidgetContainer);
    WidgetContainerGUI temp = new WidgetContainerGUI(tempWidgetContainer, this);
    guiEditArea.add(temp);
    tempWidgetContainer.ix = bufferX;
    tempWidgetContainer.iy = bufferY;
    temp.setLocation(bufferX, bufferY);
  }

  void addFLPanel(FLpanel flPanel) {
    WidgetContainerGUI temp = new WidgetContainerGUI(flPanel, this);
    guiEditArea.add(temp);
    temp.setLocation(flPanel.ix, flPanel.iy);
    temp.populate();
  }

  void populateProperty(JComponent jComp) {
    ((WidgetEditGUI)jComp).setMain(this);
    propertyPane.removeAll();
    propertyPane.add(jComp, BorderLayout.CENTER);
    propertyPane.revalidate();
    propertyPane.repaint();
  }

  String generateText() {
    StringBuffer output = new StringBuffer();
    output.append("\n");

    Iterator iter = widgets.iterator();
    while(iter.hasNext()) {
      output.append(((Widget)(iter.next())).generateText() + "\n");
    }

    output.append("\tFLrun\n");
    return output.toString();
  }

  public void updateWidgets() {
    guiEditArea.revalidate();
    guiEditArea.repaint();
  }

  void outputPane_componentShown(ComponentEvent e) {
    outputText.setText(generateText());
  }

  private void populate() {
    int size = widgets.size();
    for(int i = 0; i < size; i++) {
      addFLPanel((FLpanel)(widgets.get(i)));
    }
  }

  /* File menu code */

  public void open() {
    //check to see if changed; ask for save
    int rValue = fileDialog.showOpenDialog(this);
    if(rValue == JFileChooser.APPROVE_OPTION) {
      File temp = fileDialog.getSelectedFile();
      if (!(temp.getName().trim().endsWith(".dcgui"))) {
        temp = new File(temp.getAbsolutePath() + ".dcgui");
      }
      open(temp);
    } else if(rValue == JFileChooser.CANCEL_OPTION) {
      statusBar.setText("Action was cancelled.");
    }
  }

  public void open(File selected) {
    File temp = selected;
    try {
      fileNew();
      XMLSerializer xmlSer = new XMLSerializer();
      BufferedReader xmlIn = new BufferedReader(new FileReader(temp));
      widgets = (ArrayList)xmlSer.read(xmlIn);
      xmlIn.close();
      populate();
      fileName = temp;
      allowSave();
    } catch (Exception e) {
      statusBar.setText("Error! Opening of " + temp.toString() + " failed!");
      e.printStackTrace();
    }
  }

  public void save() {
    if(saveAllowed) {
      try {
        XMLSerializer xmlSer = new XMLSerializer();
        PrintWriter out = new PrintWriter(new FileWriter(fileName));
        xmlSer.write(out, widgets);
        out.flush();
        out.close();
        statusBar.setText("File " + fileName.getName() + " was succesfully saved.");
      } catch(Exception e) {
        statusBar.setText("Error! Saving of " + fileName.toString() + " failed!");
        e.printStackTrace();
      }
    }
  }

  public void saveAs() {
  int rValue = fileDialog.showSaveDialog(this);
    if(rValue == JFileChooser.APPROVE_OPTION) {
        File temp = fileDialog.getSelectedFile();
        if (!(temp.getName().trim().endsWith(".dcgui"))) {
          temp = new File(temp.getAbsolutePath() + ".dcgui");
        }
        try {
          XMLSerializer xmlSer = new XMLSerializer();
          PrintWriter out = new PrintWriter(new FileWriter(temp));
          xmlSer.write(out, widgets);
          out.flush();
          out.close();
          statusBar.setText("File saved as: " + temp.getName());
          fileName = temp;
          temp = null;
          allowSave();
        } catch(Exception e) {
          statusBar.setText("Error! Saving of " + temp.toString() + " failed!");
          System.err.println("saveAs() error");
          e.printStackTrace();
        }
    }
    if(rValue == JFileChooser.CANCEL_OPTION) {
      statusBar.setText("Action was cancelled.");
    }
  }

  public void fileNew() {
    guiEditArea.removeAll();
    widgets = new ArrayList();
    guiEditArea.revalidate();
    guiEditArea.repaint();
    propertyPane.removeAll();
    propertyPane.revalidate();
    propertyPane.repaint();
    forbidSave();
  }

  // Utility methods for other file methods
  private void allowSave() {
    saveAllowed = true;
    fileSave.setEnabled(true);
  }

  private void forbidSave() {
    saveAllowed = false;
    fileSave.setEnabled(false);
  }

}

  /** File Filter for file dialog */
  class DCGUIFilter extends javax.swing.filechooser.FileFilter {

    public DCGUIFilter() {
    }
    public boolean accept(File f) {
        if (f.isDirectory()) {
          return true;
        }
        String extension = getExtension(f);
        if (extension != null) {
          if (extension.equals("dcgui")) {
            return true;
          } else {
            return false;
          }
        }
      return false;
    }

    public String getDescription() {
      return "DC GUI Builder File (*.dcgui)";
    }

    public static String getExtension(File f) {
      String ext = null;
      String s = f.getName();
      int i = s.lastIndexOf('.');

      if (i > 0 &&  i < s.length() - 1) {
        ext = s.substring(i+1).toLowerCase();
      }
      return ext;
    }


  }
