package dcguibuilder;

/**
 * Title:        Direct Csound GUI Builder
 * Description:  program to graphically build GUI's for Gabriel Maldonado's Direct Csound GUI Opcodes
 * Copyright:    Copyright (c) 2001
 * Company:      steven yi music
 * @author steven yi
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class WidgetOtherEditGUI extends JComponent implements WidgetEditGUI{
  DCGUIMain main;
  WidgetOther widgetOther;
  int type;

  JLabel koutLabel = new JLabel();
  JLabel ihandleLabel = new JLabel();
  JTextField koutText = new JTextField();
  JTextField ihandleText = new JTextField();
  JLabel labelLabel = new JLabel();
  JLabel ioffLabel = new JLabel();
  JLabel itypeLabel = new JLabel();
  JTextField labelText = new JTextField();
  JTextField ioffText = new JTextField();
  JLabel iwidthLabel = new JLabel();
  JLabel iheightLabel = new JLabel();
  JLabel ixLabel = new JLabel();
  JLabel iyLabel = new JLabel();
  JTextField iwidthText = new JTextField();
  JTextField iheightText = new JTextField();
  JTextField iyText = new JTextField();
  JTextField ixText = new JTextField();
  JComboBox itypeComboBox = new JComboBox();
  JTextField ionText = new JTextField();
  JLabel ionLabel = new JLabel();

  public WidgetOtherEditGUI(WidgetOther widgetOther, int type) {
    this.widgetOther = widgetOther;
    this.type = type;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    koutLabel.setText("kout");
    koutLabel.setBounds(new Rectangle(4, 5, 41, 17));
    this.setPreferredSize(new Dimension(200, 300));
    ihandleLabel.setBounds(new Rectangle(4, 27, 41, 17));
    ihandleLabel.setToolTipText("");
    ihandleLabel.setText("ihandle");
    koutText.setBounds(new Rectangle(52, 5, 124, 21));
    ihandleText.setBounds(new Rectangle(52, 27, 124, 21));
    labelLabel.setText("label");
    labelLabel.setBounds(new Rectangle(4, 50, 41, 17));
    ioffLabel.setText("ioff");
    ioffLabel.setBounds(new Rectangle(4, 95, 41, 17));
    itypeLabel.setText("itype");
    itypeLabel.setBounds(new Rectangle(4, 118, 41, 17));
    labelText.setBounds(new Rectangle(52, 50, 124, 21));
    ioffText.setBounds(new Rectangle(52, 95, 124, 21));
    iwidthLabel.setText("iwidth");
    iwidthLabel.setBounds(new Rectangle(4, 141, 41, 17));
    iheightLabel.setText("iheight");
    iheightLabel.setBounds(new Rectangle(4, 163, 41, 17));
    ixLabel.setText("ix");
    ixLabel.setBounds(new Rectangle(4, 186, 41, 17));
    iyLabel.setText("iy");
    iyLabel.setBounds(new Rectangle(4, 208, 41, 17));
    iwidthText.setBounds(new Rectangle(52, 141, 124, 21));
    iheightText.setBounds(new Rectangle(52, 163, 124, 21));
    iyText.setBounds(new Rectangle(52, 208, 124, 21));
    ixText.setBounds(new Rectangle(52, 186, 124, 21));
    itypeComboBox.setBounds(new Rectangle(52, 118, 124, 21));
    ionText.setBounds(new Rectangle(52, 73, 124, 21));
    ionLabel.setText("ion");
    ionLabel.setBounds(new Rectangle(4, 73, 41, 17));
    this.add(koutLabel, null);
    this.add(ihandleLabel, null);
    this.add(labelLabel, null);
    this.add(koutText, null);
    this.add(ihandleText, null);
    this.add(labelText, null);
    populateFields();
    setupTextBoxes();
    this.add(ionText, null);
    this.add(ionLabel, null);
    this.add(ioffLabel, null);
    this.add(ioffText, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
  }

  public void setMain(DCGUIMain main) {
    this.main = main;
  }

  public void populateFields() {
    koutText.setText(widgetOther.kout);
    ihandleText.setText(widgetOther.ihandle);
    labelText.setText(widgetOther.label);
    ionText.setText(Integer.toString(widgetOther.ion));
    ioffText.setText(Integer.toString(widgetOther.ioff));
    iwidthText.setText(Integer.toString(widgetOther.iwidth));
    iheightText.setText(Integer.toString(widgetOther.iheight));
    ixText.setText(Integer.toString(widgetOther.ix));
    iyText.setText(Integer.toString(widgetOther.iy));
    populateType(type);

    itypeComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String text = itypeComboBox.getSelectedItem().toString();
        text = text.substring(0,1);
        widgetOther.itype = checkNumber(text);
      }
    });
    this.add(ioffText, null);
    this.add(ioffLabel, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iyLabel, null);
    this.add(ionText, null);
    this.add(ionLabel, null);
    this.add(iwidthText, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
  }

  public void populateType(int type) {
    Vector itypes = new Vector();
    switch(type){
      case 1:
          itypes.add("1 - normal button");
          itypes.add("2 - light button");
          itypes.add("3 - check button");
          itypes.add("4 - round button");
        break;
      case 2:
        return;
      case 3:
          itypes.add("1 - flat box");
          itypes.add("2 - up box");
          itypes.add("3 - down box");
          itypes.add("4 - thin up box");
          itypes.add("5 - thin down box");
          itypes.add("6 - engraved box");
          itypes.add("7 - embossed box");
          itypes.add("8 - border box");
          itypes.add("9 - shadow box");
          itypes.add("10 - rounded box");
          itypes.add("11 - rounded box with shadow");
          itypes.add("12 - rounded flat box");
          itypes.add("13 - rounded up box");
          itypes.add("14 - rounded down box");
          itypes.add("15 - diamond up box");
          itypes.add("16 - diamond down box");
          itypes.add("17 - oval box");
          itypes.add("18 - oval shadow box");
          itypes.add("19 - oval flat box");
        break;
     }
    itypeComboBox.setModel(new DefaultComboBoxModel(itypes));
    itypeComboBox.setSelectedIndex(widgetOther.itype - 1);
  }

  public int checkNumber(String input) {
    int x;
    try {
       x = Integer.parseInt(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public float checkNumFloat(String input) {
    float x;
    try {
       x = Float.parseFloat(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public void setupTextBoxes() {
    koutText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
    });

    ihandleText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
    });

    ionText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ion = checkNumber(ionText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ion = checkNumber(ionText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ion = checkNumber(ionText.getText());
      }
    });

    ioffText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ioff = checkNumber(ioffText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ioff = checkNumber(ioffText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ioff = checkNumber(ioffText.getText());
      }
    });

    labelText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
    });

    iwidthText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
    });
    iheightText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
    });
    ixText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
    });

    iyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
    });

  }

}