package dcguibuilder;

/**
 * Title:        Direct Csound GUI Builder
 * Description:  program to graphically build GUI's for Gabriel Maldonado's Direct Csound GUI Opcodes
 * Copyright:    Copyright (c) 2001
 * Company:      steven yi music
 * @author steven yi
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class WidgetOtherEditGUI2 extends JComponent implements WidgetEditGUI{
  DCGUIMain main;
  WidgetOther widgetOther;

  JLabel koutLabel = new JLabel();
  JLabel ihandleLabel = new JLabel();
  JTextField koutText = new JTextField();
  JTextField ihandleText = new JTextField();
  JLabel inumyLabel = new JLabel();
  JLabel itypeLabel = new JLabel();
  JTextField inumyText = new JTextField();
  JLabel iwidthLabel = new JLabel();
  JLabel iheightLabel = new JLabel();
  JLabel ixLabel = new JLabel();
  JLabel iyLabel = new JLabel();
  JTextField iwidthText = new JTextField();
  JTextField iheightText = new JTextField();
  JTextField iyText = new JTextField();
  JTextField ixText = new JTextField();
  JComboBox itypeComboBox = new JComboBox();
  JTextField inumxText = new JTextField();
  JLabel inumxLabel = new JLabel();
  JLabel iopcodeLabel = new JLabel();
  JTextField iopcodeText = new JTextField();

  public WidgetOtherEditGUI2(WidgetOther widgetOther) {
    this.widgetOther = widgetOther;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    koutLabel.setText("kout");
    koutLabel.setBounds(new Rectangle(4, 5, 41, 17));
    this.setPreferredSize(new Dimension(200, 300));
    ihandleLabel.setBounds(new Rectangle(4, 27, 41, 17));
    ihandleLabel.setToolTipText("");
    ihandleLabel.setText("ihandle");
    koutText.setBounds(new Rectangle(55, 5, 124, 21));
    ihandleText.setBounds(new Rectangle(55, 27, 124, 21));
    inumyLabel.setText("inumy");
    inumyLabel.setBounds(new Rectangle(4, 94, 41, 17));
    itypeLabel.setText("itype");
    itypeLabel.setBounds(new Rectangle(4, 50, 41, 17));
    inumyText.setBounds(new Rectangle(55, 94, 124, 21));
    iwidthLabel.setText("iwidth");
    iwidthLabel.setBounds(new Rectangle(4, 116, 41, 17));
    iheightLabel.setText("iheight");
    iheightLabel.setBounds(new Rectangle(4, 138, 41, 17));
    ixLabel.setText("ix");
    ixLabel.setBounds(new Rectangle(4, 161, 41, 17));
    iyLabel.setText("iy");
    iyLabel.setBounds(new Rectangle(4, 183, 41, 17));
    iwidthText.setBounds(new Rectangle(55, 116, 124, 21));
    iheightText.setBounds(new Rectangle(55, 138, 124, 21));
    iyText.setBounds(new Rectangle(55, 183, 124, 21));
    ixText.setBounds(new Rectangle(55, 161, 124, 21));
    itypeComboBox.setBounds(new Rectangle(55, 50, 124, 21));
    inumxText.setBounds(new Rectangle(55, 72, 124, 21));
    inumxLabel.setText("inumx");
    inumxLabel.setBounds(new Rectangle(4, 72, 41, 17));
    iopcodeLabel.setBounds(new Rectangle(4, 205, 46, 17));
    iopcodeLabel.setToolTipText("");
    iopcodeLabel.setText("iopcode");
    iopcodeText.setBounds(new Rectangle(55, 205, 124, 21));
    this.add(koutLabel, null);
    this.add(ihandleLabel, null);
    populateFields();
    setupTextBoxes();
    this.add(inumxLabel, null);
    this.add(inumyLabel, null);
    this.add(inumyText, null);
    this.add(itypeLabel, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iopcodeLabel, null);
    this.add(iopcodeText, null);
    this.add(inumxText, null);
    this.add(koutText, null);
    this.add(iopcodeText, null);
    this.add(iyText, null);
    this.add(ixText, null);
    this.add(iheightText, null);
    this.add(iwidthText, null);
    this.add(inumyText, null);
    this.add(inumxText, null);
    this.add(itypeComboBox, null);
    this.add(ihandleText, null);
  }

  public void setMain(DCGUIMain main) {
    this.main = main;
  }

  public void populateFields() {
    koutText.setText(widgetOther.kout);
    ihandleText.setText(widgetOther.ihandle);
    inumxText.setText(Integer.toString(widgetOther.inumx));
    inumyText.setText(Integer.toString(widgetOther.inumy));
    iwidthText.setText(Integer.toString(widgetOther.iwidth));
    iheightText.setText(Integer.toString(widgetOther.iheight));
    ixText.setText(Integer.toString(widgetOther.ix));
    iyText.setText(Integer.toString(widgetOther.iy));
    iopcodeText.setText(widgetOther.iopcode);
    populateType();

    itypeComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String text = itypeComboBox.getSelectedItem().toString();
        text = text.substring(0,1);
        widgetOther.itype = checkNumber(text);
      }
    });
    this.add(inumyText, null);
    this.add(inumyLabel, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iyLabel, null);
    this.add(inumxText, null);
    this.add(inumxLabel, null);
    this.add(iwidthText, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(inumxText, null);
    this.add(inumxLabel, null);
    this.add(inumyLabel, null);
    this.add(inumyText, null);
    this.add(inumyText, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iopcodeText, null);
    this.add(iopcodeLabel, null);
  }

  public void populateType() {
    Vector itypes = new Vector();
    itypes.add("1 - normal button");
    itypes.add("2 - light button");
    itypes.add("3 - check button");
    itypes.add("4 - round button");
    itypeComboBox.setModel(new DefaultComboBoxModel(itypes));
    itypeComboBox.setSelectedIndex(widgetOther.itype - 1);
  }

  public int checkNumber(String input) {
    int x;
    try {
       x = Integer.parseInt(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public float checkNumFloat(String input) {
    float x;
    try {
       x = Float.parseFloat(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public void setupTextBoxes() {
    koutText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.kout = koutText.getText();
      }
    });

    ihandleText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
    });

    inumxText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.inumx = checkNumber(inumxText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.inumx = checkNumber(inumxText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.inumx = checkNumber(inumxText.getText());
      }
    });

    inumyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.inumy = checkNumber(inumyText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.inumy = checkNumber(inumyText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.inumy = checkNumber(inumyText.getText());
      }
    });

    iwidthText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
    });
    iheightText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
    });
    ixText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
    });

    iyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
    });

    iopcodeText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iopcode = iopcodeText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iopcode = iopcodeText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iopcode = iopcodeText.getText();
      }
    });
  }

}