package dcguibuilder;

/**
 * Title:        Direct Csound GUI Builder
 * Description:  program to graphically build GUI's for Gabriel Maldonado's Direct Csound GUI Opcodes
 * Copyright:    Copyright (c) 2001
 * Company:      steven yi music
 * @author steven yi
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class WidgetOtherEditGUI3 extends JComponent implements WidgetEditGUI{
  DCGUIMain main;
  WidgetOther widgetOther;

  JLabel ihandleLabel = new JLabel();
  JTextField ihandleText = new JTextField();
  JLabel isizeLabel = new JLabel();
  JLabel itypeLabel = new JLabel();
  JTextField isizeText = new JTextField();
  JLabel iwidthLabel = new JLabel();
  JLabel iheightLabel = new JLabel();
  JLabel ixLabel = new JLabel();
  JLabel iyLabel = new JLabel();
  JTextField iwidthText = new JTextField();
  JTextField iheightText = new JTextField();
  JTextField iyText = new JTextField();
  JTextField ixText = new JTextField();
  JComboBox itypeComboBox = new JComboBox();
  JLabel ifontLabel = new JLabel();
  JComboBox ifontComboBox = new JComboBox();
  JTextField labelText = new JTextField();
  JLabel labelLabel = new JLabel();

  public WidgetOtherEditGUI3(WidgetOther widgetOther) {
    this.widgetOther = widgetOther;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setPreferredSize(new Dimension(200, 300));
    ihandleLabel.setBounds(new Rectangle(4, 4, 41, 17));
    ihandleLabel.setToolTipText("");
    ihandleLabel.setText("ihandle");
    ihandleText.setBounds(new Rectangle(55, 4, 124, 21));
    isizeLabel.setText("isize");
    isizeLabel.setBounds(new Rectangle(4, 93, 41, 17));
    itypeLabel.setText("itype");
    itypeLabel.setBounds(new Rectangle(4, 49, 41, 17));
    isizeText.setBounds(new Rectangle(55, 93, 124, 21));
    iwidthLabel.setText("iwidth");
    iwidthLabel.setBounds(new Rectangle(4, 115, 41, 17));
    iheightLabel.setText("iheight");
    iheightLabel.setBounds(new Rectangle(4, 137, 41, 17));
    ixLabel.setText("ix");
    ixLabel.setBounds(new Rectangle(4, 160, 41, 17));
    iyLabel.setText("iy");
    iyLabel.setBounds(new Rectangle(4, 182, 41, 17));
    iwidthText.setBounds(new Rectangle(55, 115, 124, 21));
    iheightText.setBounds(new Rectangle(55, 137, 124, 21));
    iyText.setBounds(new Rectangle(55, 182, 124, 21));
    ixText.setBounds(new Rectangle(55, 160, 124, 21));
    itypeComboBox.setBounds(new Rectangle(55, 49, 124, 21));
    ifontLabel.setText("ifont");
    ifontLabel.setBounds(new Rectangle(4, 71, 41, 17));
    ifontComboBox.setBounds(new Rectangle(55, 71, 124, 21));
    labelText.setText(widgetOther.ihandle);
    labelText.setBounds(new Rectangle(55, 27, 124, 21));
    labelLabel.setText("label");
    labelLabel.setToolTipText("");
    labelLabel.setBounds(new Rectangle(4, 27, 41, 17));
    this.add(ihandleLabel, null);
    populateFields();
    setupTextBoxes();
    this.add(ifontLabel, null);
    this.add(isizeLabel, null);
    this.add(isizeText, null);
    this.add(itypeLabel, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iyText, null);
    this.add(ixText, null);
    this.add(iheightText, null);
    this.add(iwidthText, null);
    this.add(isizeText, null);
    this.add(itypeComboBox, null);
    this.add(ihandleText, null);
    this.add(ifontComboBox, null);
    this.add(labelText, null);
    this.add(labelLabel, null);
  }

  public void setMain(DCGUIMain main) {
    this.main = main;
  }

  public void populateFields() {
    ihandleText.setText(widgetOther.ihandle);
    labelText.setText(widgetOther.label);
    isizeText.setText(Integer.toString(widgetOther.isize));
    iwidthText.setText(Integer.toString(widgetOther.iwidth));
    iheightText.setText(Integer.toString(widgetOther.iheight));
    ixText.setText(Integer.toString(widgetOther.ix));
    iyText.setText(Integer.toString(widgetOther.iy));
    populateType();

    itypeComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String text = itypeComboBox.getSelectedItem().toString();
        text = text.substring(0,1);
        widgetOther.itype = checkNumber(text);
      }
    });

    ifontComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String text = ifontComboBox.getSelectedItem().toString();
        text = text.substring(0,1);
        widgetOther.ifont = checkNumber(text);
      }
    });

    this.add(isizeText, null);
    this.add(isizeLabel, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iyLabel, null);
    this.add(ifontLabel, null);
    this.add(iwidthText, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(ifontLabel, null);
    this.add(isizeLabel, null);
    this.add(isizeText, null);
    this.add(isizeText, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(itypeComboBox, null);
    this.add(itypeLabel, null);
    this.add(ifontLabel, null);
    this.add(ifontComboBox, null);
    this.add(isizeLabel, null);
    this.add(isizeText, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(ihandleText, null);
    this.add(ihandleLabel, null);
    this.add(ifontLabel, null);
    this.add(isizeLabel, null);
    this.add(isizeText, null);
    this.add(itypeLabel, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(itypeComboBox, null);
    this.add(ifontComboBox, null);
    this.add(labelText, null);
    this.add(labelLabel, null);
  }

  public void populateType() {
    Vector itypes = new Vector();
      itypes.add("1 - flat box");
      itypes.add("2 - up box");
      itypes.add("3 - down box");
      itypes.add("4 - thin up box");
      itypes.add("5 - thin down box");
      itypes.add("6 - engraved box");
      itypes.add("7 - embossed box");
      itypes.add("8 - border box");
      itypes.add("9 - shadow box");
      itypes.add("10 - rounded box");
      itypes.add("11 - rounded box with shadow");
      itypes.add("12 - rounded flat box");
      itypes.add("13 - rounded up box");
      itypes.add("14 - rounded down box");
      itypes.add("15 - diamond up box");
      itypes.add("16 - diamond down box");
      itypes.add("17 - oval box");
      itypes.add("18 - oval shadow box");
      itypes.add("19 - oval flat box");

    Vector ifonts = new Vector();
      ifonts.add("1 - helvetica");
      ifonts.add("2 - helvetica bold");
      ifonts.add("3 - helvetica italic");
      ifonts.add("4 - helvetica bold italic");
      ifonts.add("5 - courier");
      ifonts.add("6 - courier bold");
      ifonts.add("7 - courier italic");
      ifonts.add("8 - courier bold italic");
      ifonts.add("9 - times");
      ifonts.add("10 - times bold");
      ifonts.add("11 - times italic");
      ifonts.add("12 - times bold italic");
      ifonts.add("13 - symbol");
      ifonts.add("14 - screen");
      ifonts.add("15 - screen bold");
      ifonts.add("16 - dingbats");

    itypeComboBox.setModel(new DefaultComboBoxModel(itypes));
    itypeComboBox.setSelectedIndex(widgetOther.itype - 1);
    ifontComboBox.setModel(new DefaultComboBoxModel(ifonts));
    ifontComboBox.setSelectedIndex(widgetOther.ifont - 1);
  }

  public int checkNumber(String input) {
    int x;
    try {
       x = Integer.parseInt(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public float checkNumFloat(String input) {
    float x;
    try {
       x = Float.parseFloat(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public void setupTextBoxes() {

    ihandleText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
    });

    labelText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
    });

    isizeText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.isize = checkNumber(isizeText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.isize = checkNumber(isizeText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.isize = checkNumber(isizeText.getText());
      }
    });

    iwidthText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
    });
    iheightText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
    });
    ixText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
    });

    iyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
    });
  }

}