package dcguibuilder;

/**
 * Title:        Direct Csound GUI Builder
 * Description:  program to graphically build GUI's for Gabriel Maldonado's Direct Csound GUI Opcodes
 * Copyright:    Copyright (c) 2001
 * Company:      steven yi music
 * @author steven yi
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class WidgetOtherEditGUI4 extends JComponent implements WidgetEditGUI{
  DCGUIMain main;
  WidgetOther widgetOther;

  JLabel ihandleLabel = new JLabel();
  JTextField ihandleText = new JTextField();
  JLabel iwidthLabel = new JLabel();
  JLabel iheightLabel = new JLabel();
  JLabel ixLabel = new JLabel();
  JLabel iyLabel = new JLabel();
  JTextField iwidthText = new JTextField();
  JTextField iheightText = new JTextField();
  JTextField iyText = new JTextField();
  JTextField ixText = new JTextField();
  JTextField labelText = new JTextField();
  JLabel labelLabel = new JLabel();

  public WidgetOtherEditGUI4(WidgetOther widgetOther) {
    this.widgetOther = widgetOther;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setPreferredSize(new Dimension(200, 300));
    ihandleLabel.setBounds(new Rectangle(4, 4, 41, 17));
    ihandleLabel.setToolTipText("");
    ihandleLabel.setText("ihandle");
    ihandleText.setBounds(new Rectangle(55, 4, 124, 21));
    iwidthLabel.setText("iwidth");
    iwidthLabel.setBounds(new Rectangle(4, 50, 41, 17));
    iheightLabel.setText("iheight");
    iheightLabel.setBounds(new Rectangle(4, 72, 41, 17));
    ixLabel.setText("ix");
    ixLabel.setBounds(new Rectangle(4, 95, 41, 17));
    iyLabel.setText("iy");
    iyLabel.setBounds(new Rectangle(4, 117, 41, 17));
    iwidthText.setBounds(new Rectangle(55, 50, 124, 21));
    iheightText.setBounds(new Rectangle(55, 72, 124, 21));
    iyText.setBounds(new Rectangle(55, 117, 124, 21));
    ixText.setBounds(new Rectangle(55, 95, 124, 21));
    labelText.setText(widgetOther.ihandle);
    labelText.setBounds(new Rectangle(55, 27, 124, 21));
    labelLabel.setText("label");
    labelLabel.setToolTipText("");
    labelLabel.setBounds(new Rectangle(4, 27, 41, 17));
    this.add(ihandleLabel, null);
    populateFields();
    setupTextBoxes();
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iyText, null);
    this.add(ixText, null);
    this.add(iheightText, null);
    this.add(iwidthText, null);
    this.add(ihandleText, null);
    this.add(labelText, null);
    this.add(labelLabel, null);
  }

  public void setMain(DCGUIMain main) {
    this.main = main;
  }

  public void populateFields() {
    ihandleText.setText(widgetOther.ihandle);
    labelText.setText(widgetOther.label);
    iwidthText.setText(Integer.toString(widgetOther.iwidth));
    iheightText.setText(Integer.toString(widgetOther.iheight));
    ixText.setText(Integer.toString(widgetOther.ix));
    iyText.setText(Integer.toString(widgetOther.iy));

    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iyLabel, null);
    this.add(iwidthText, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(ihandleText, null);
    this.add(ihandleLabel, null);
    this.add(iwidthText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);
    this.add(iyText, null);
    this.add(labelText, null);
    this.add(labelLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iyLabel, null);
    this.add(iwidthLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
  }

  public int checkNumber(String input) {
    int x;
    try {
       x = Integer.parseInt(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public float checkNumFloat(String input) {
    float x;
    try {
       x = Float.parseFloat(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public void setupTextBoxes() {

    ihandleText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ihandle = ihandleText.getText();
      }
    });

    labelText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.label = labelText.getText();
      }
    });

    iwidthText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
    });
    iheightText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
    });
    ixText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
    });

    iyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetOther.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
    });
  }

}