package dcguibuilder;

/**
 * Title:        Direct Csound GUI Builder
 * Description:  program to graphically build GUI's for Gabriel Maldonado's Direct Csound GUI Opcodes
 * Copyright:    Copyright (c) 2001
 * Company:      steven yi music
 * @author steven yi
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class WidgetValuatorEditGUI3 extends JComponent implements WidgetEditGUI{
  DCGUIMain main;
  WidgetValuator widgetValuator;
  int type;

  JLabel koutLabel = new JLabel();
  JLabel ihandleLabel = new JLabel();
  JTextField koutText = new JTextField();
  JTextField ihandleText = new JTextField();
  JLabel labelLabel = new JLabel();
  JLabel iminLabel = new JLabel();
  JLabel imaxLabel = new JLabel();
  JLabel itypeLabel = new JLabel();
  JTextField labelText = new JTextField();
  JTextField iminText = new JTextField();
  JTextField imaxText = new JTextField();
  JLabel iwidthLabel = new JLabel();
  JLabel iheightLabel = new JLabel();
  JLabel ixLabel = new JLabel();
  JLabel iyLabel = new JLabel();
  JTextField iwidthText = new JTextField();
  JTextField iheightText = new JTextField();
  JTextField iyText = new JTextField();
  JTextField ixText = new JTextField();
  JComboBox itypeComboBox = new JComboBox();
  JTextField istepText = new JTextField();
  JLabel istepLabel = new JLabel();

  public WidgetValuatorEditGUI3(WidgetValuator widgetValuator, int type) {
    this.widgetValuator = widgetValuator;
    this.type = type;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    koutLabel.setText("kout");
    koutLabel.setBounds(new Rectangle(4, 5, 41, 17));
    this.setPreferredSize(new Dimension(200, 300));
    ihandleLabel.setBounds(new Rectangle(4, 27, 41, 17));
    ihandleLabel.setToolTipText("");
    ihandleLabel.setText("ihandle");
    koutText.setBounds(new Rectangle(52, 5, 124, 21));
    ihandleText.setBounds(new Rectangle(52, 27, 124, 21));
    labelLabel.setText("label");
    labelLabel.setBounds(new Rectangle(4, 50, 41, 17));
    iminLabel.setToolTipText("");
    iminLabel.setText("imin");
    iminLabel.setBounds(new Rectangle(4, 72, 41, 17));
    imaxLabel.setText("imax");
    imaxLabel.setBounds(new Rectangle(4, 94, 41, 17));
    itypeLabel.setText("itype");
    itypeLabel.setBounds(new Rectangle(4, 140, 41, 17));
    labelText.setBounds(new Rectangle(52, 50, 124, 21));
    iminText.setBounds(new Rectangle(52, 72, 124, 21));
    imaxText.setBounds(new Rectangle(52, 94, 124, 21));
    iwidthLabel.setText("iwidth");
    iwidthLabel.setBounds(new Rectangle(4, 163, 41, 17));
    iheightLabel.setText("iheight");
    iheightLabel.setBounds(new Rectangle(4, 185, 41, 17));
    ixLabel.setText("ix");
    ixLabel.setBounds(new Rectangle(4, 208, 41, 17));
    iyLabel.setText("iy");
    iyLabel.setBounds(new Rectangle(4, 230, 41, 17));
    iwidthText.setBounds(new Rectangle(52, 163, 124, 21));
    iheightText.setBounds(new Rectangle(52, 185, 124, 21));
    iyText.setBounds(new Rectangle(52, 230, 124, 21));
    ixText.setBounds(new Rectangle(52, 208, 124, 21));
    itypeComboBox.setBounds(new Rectangle(52, 140, 124, 21));
    istepText.setBounds(new Rectangle(52, 117, 124, 21));
    istepLabel.setText("istep");
    istepLabel.setBounds(new Rectangle(4, 117, 41, 17));
    this.add(koutLabel, null);
    this.add(ihandleLabel, null);
    this.add(labelLabel, null);
    this.add(iminLabel, null);
    this.add(imaxLabel, null);
    this.add(itypeLabel, null);
    this.add(koutText, null);
    this.add(ihandleText, null);
    this.add(labelText, null);
    this.add(iminText, null);
    this.add(imaxText, null);
    this.add(iwidthLabel, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(iyLabel, null);
    this.add(iwidthText, null);
    this.add(iyText, null);
    this.add(iheightText, null);
    this.add(ixText, null);
    this.add(itypeComboBox, null);
    populateFields();
    setupTextBoxes();
  }

  public void setMain(DCGUIMain main) {
    this.main = main;
  }

  public void populateFields() {
    koutText.setText(widgetValuator.kout);
    ihandleText.setText(widgetValuator.ihandle);
    labelText.setText(widgetValuator.label);
    iminText.setText(Integer.toString(widgetValuator.imin));
    imaxText.setText(Integer.toString(widgetValuator.imax));
    istepText.setText(Float.toString(widgetValuator.istep));
    iwidthText.setText(Integer.toString(widgetValuator.iwidth));
    iheightText.setText(Integer.toString(widgetValuator.iheight));
    ixText.setText(Integer.toString(widgetValuator.ix));
    iyText.setText(Integer.toString(widgetValuator.iy));
    populateType(type);

    itypeComboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String text = itypeComboBox.getSelectedItem().toString();
        text = text.substring(0,1);
        widgetValuator.itype = checkNumber(text);
      }
    });
    this.add(itypeLabel, null);
    this.add(itypeComboBox, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightText, null);
    this.add(iheightLabel, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyText, null);
    this.add(iyLabel, null);
    this.add(istepText, null);
    this.add(istepLabel, null);
    this.add(itypeComboBox, null);
    this.add(itypeLabel, null);
    this.add(iyText, null);
    this.add(iwidthLabel, null);
    this.add(iwidthText, null);
    this.add(iheightLabel, null);
    this.add(iheightText, null);
    this.add(ixLabel, null);
    this.add(ixText, null);
    this.add(iyLabel, null);

  }

  public void populateType(int type) {
    Vector itypes = new Vector();
    switch(type){
      case 1:
          itypes.add("1 - horizontal fill slider");
          itypes.add("2 - vertical fill slider");
          itypes.add("3 - horizontal engraved slider");
          itypes.add("4 - vertical engraved slider");
          itypes.add("5 - horizontal nice slider");
          itypes.add("6 - vertical nice slider");
        break;
      case 2:
          itypes.add("1 - 3D knob");
          itypes.add("2 - pie-like knob");
          itypes.add("3 - clock-like knob");
          itypes.add("4 - flat-knob");
        break;
      case 3:
          itypes.add("1 - horizontal roller");
          itypes.add("2 - vertical roller");
        break;
      case 4:
          itypes.add("1 - normal behaviour");
          itypes.add("2 - drag operation suppressed");
          itypes.add("3 - text edit suppressed");
        break;
      case 5:
        itypeComboBox.disable();
        return;
      case 6:
        return;
    }
    itypeComboBox.setModel(new DefaultComboBoxModel(itypes));
    itypeComboBox.setSelectedIndex(widgetValuator.itype - 1);
  }

  public int checkNumber(String input) {
    int x;
    try {
       x = Integer.parseInt(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public float checkNumFloat(String input) {
    float x;
    try {
       x = Float.parseFloat(input);
    } catch (NumberFormatException ne) {
      x = 0;
    }
    if (x < -1) { x = 0; }
    return x;
  }

  public void setupTextBoxes() {
    koutText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.kout = koutText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.kout = koutText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.kout = koutText.getText();
      }
    });

    ihandleText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.ihandle = ihandleText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.ihandle = ihandleText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.ihandle = ihandleText.getText();
      }
    });

    iminText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.imin = checkNumber(iminText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.imin = checkNumber(iminText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.imin = checkNumber(iminText.getText());
      }
    });

    imaxText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.imax = checkNumber(imaxText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.imax = checkNumber(imaxText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.imax = checkNumber(imaxText.getText());
      }
    });

    istepText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.istep = checkNumFloat(istepText.getText());
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.istep = checkNumFloat(istepText.getText());
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.istep = checkNumFloat(istepText.getText());
      }
    });

    labelText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.label = labelText.getText();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.label = labelText.getText();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.label = labelText.getText();
      }
    });

    iwidthText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.iwidth = checkNumber(iwidthText.getText());
        main.updateWidgets();
      }
    });
    iheightText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.iheight = checkNumber(iheightText.getText());
        main.updateWidgets();
      }
    });
    ixText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.ix = checkNumber(ixText.getText());
        main.updateWidgets();
      }
    });

    iyText.getDocument().addDocumentListener(new DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        widgetValuator.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void removeUpdate(DocumentEvent e) {
        widgetValuator.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
      public void changedUpdate(DocumentEvent e) {
        widgetValuator.iy = checkNumber(iyText.getText());
        main.updateWidgets();
      }
    });

  }

}